# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
from .finish_reason import FinishReason
import pydantic
from .chat_completion_response_message import ChatCompletionResponseMessage
from ..core.pydantic_utilities import IS_PYDANTIC_V2
import typing


class Choice(UniversalBaseModel):
    finish_reason: FinishReason = pydantic.Field()
    """
    The reason the model stopped generating tokens. This will be `stop` if the model hit a natural stop point or a provided stop sequence,
    `length` if the maximum number of tokens specified in the request was reached,
    `content_filter` if content was omitted due to a flag from our content filters,
    `tool_calls` if the model called a tool, or `function_call` (deprecated) if the model called a function.
    """

    index: int = pydantic.Field()
    """
    The index of the choice in the list of choices.
    """

    message: ChatCompletionResponseMessage

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
